/*
 * PT2001.h
 *
 *  Created on: Jul 28, 2016
 *      Author: B39483
 */

#ifndef PT2001_H_
#define PT2001_H_

#include "stdint.h"
#include "stdbool.h"
#include "PT2001_LoadData.h"

#define CODE_RAM1 0
#define CODE_RAM2 1
#define CODE_RAM3 2
#define DATA_RAM  3

#define CH1_REG   0
#define CH2_REG   1
#define CH3_REG   2
#define DIAG_REG  3
#define IO_REG    4
#define MAIN_REG  5

uint16_t send_single_PT2001_SPI_Cmd(bool bRead, uint16_t offset, uint16_t txData);
bool send_PT2001_SPI_Cmd(bool bRead, uint16_t start_addr, uint16_t length, uint16_t* pTxData, uint16_t* pRxData);


void ProgramDevice();
void download_RAM(int target);
void download_register(int r_target);

bool ID_Check ();
bool CLK_check();
bool Driver_Status_Init ();
bool DRVEN_check();
bool BIST_check(_Bool BIST_run);
bool OA_path_check(_Bool OA1_check, _Bool OA2_check);
bool Checksum_check();
uint16_t Read_VbatADC ();
unsigned long Bootstrap_check ();
void Device_Lock_Unlock (unsigned char Lock_Unlock);
void Tracer (unsigned int trace_start, unsigned int trace_stop, _Bool ucore, unsigned char channel , unsigned char post_trigger_length, _Bool trace_enable);

#endif /* PT2001_H_ */
