/*
 * gpio.h
 *
 *  Created on: Apr 11, 2016
 *      Author: B52321
 */

#ifndef GPIO_H_
#define GPIO_H_

#include "fsl_gpio_hal.h"

#define LED_PORT 	PORTD
#define PCC_CLOCK	PCC_PORTD_CLOCK
#define LED_RED		15U
#define LED_GREEN   16U
#define LOW       0
#define HIGH      1

extern void init_GPIO(void);
extern void set_reset_pin(int state);
extern void set_drven_pin(int state);

#define SET_RESETB_HIGH     GPIO_HAL_SetPins(PTA,(1<<2))
#define SET_RESETB_LOW      GPIO_HAL_ClearPins(PTA,(1<<2))
#define SET_DRVEN_HIGH      GPIO_HAL_SetPins(PTA, 1<<9);
#define SET_DRVEN_LOW       GPIO_HAL_ClearPins(PTA, 1<<9);
#define SET_START1_HIGH     GPIO_HAL_SetPins(PTB,(1<<8))
#define SET_START1_LOW		GPIO_HAL_ClearPins(PTB,(1<<8))
#define SET_START2_HIGH		GPIO_HAL_SetPins(PTB,(1<<9))
#define SET_START2_LOW		GPIO_HAL_ClearPins(PTB,(1<<9))
#define SET_START3_HIGH		GPIO_HAL_SetPins(PTB,(1<<10))
#define SET_START3_LOW		GPIO_HAL_ClearPins(PTB,(1<<10))
#define SET_START4_HIGH		GPIO_HAL_SetPins(PTB,(1<<11))
#define SET_START4_LOW  	GPIO_HAL_ClearPins(PTB,(1<<11))
#define SET_START5_HIGH		GPIO_HAL_SetPins(PTC,(1<<10))
#define SET_START5_LOW		GPIO_HAL_ClearPins(PTC,(1<<10))
#define SET_START6_HIGH		GPIO_HAL_SetPins(PTC,(1<<11))
#define SET_START6_LOW		GPIO_HAL_ClearPins(PTC,(1<<11))
#define SET_START7_HIGH		GPIO_HAL_SetPins(PTD,(1<<13))
#define SET_START7_LOW		GPIO_HAL_ClearPins(PTD,(1<<13))
#define SET_START8_HIGH		GPIO_HAL_SetPins(PTA,(1<<8))
#define SET_START8_LOW		GPIO_HAL_ClearPins(PT,(1<<))

#define LED_INJ1_ON         GPIO_HAL_SetPins(PTB,(1<<1))
#define LED_INJ1_OFF		GPIO_HAL_ClearPins(PTB,(1<<1))
#define LED_IGN1_ON         GPIO_HAL_SetPins(PTA,(1<<6))
#define LED_IGN1_OFF		GPIO_HAL_ClearPins(PTA,(1<<6))
#define LED_INJ2_ON         GPIO_HAL_SetPins(PTC,(1<<0))
#define LED_INJ2_OFF		GPIO_HAL_ClearPins(PTC,(1<<0))
#define LED_IGN2_ON         GPIO_HAL_SetPins(PTE,(1<<2))
#define LED_IGN2_OFF		GPIO_HAL_ClearPins(PTE,(1<<2))
#define LED_INJ3_ON         GPIO_HAL_SetPins(PTE,(1<<6))
#define LED_INJ3_OFF		GPIO_HAL_ClearPins(PTE,(1<<6))
#define LED_IGN3_ON         GPIO_HAL_SetPins(PTC,(1<<3))
#define LED_IGN3_OFF		GPIO_HAL_ClearPins(PTC,(1<<3))
#define LED_INJ4_ON         GPIO_HAL_SetPins(PTC,(1<<6))
#define LED_INJ4_OFF		GPIO_HAL_ClearPins(PTC,(1<<6))
#define LED_IGN4_ON         GPIO_HAL_SetPins(PTB,(1<<16))
#define LED_IGN4_OFF		GPIO_HAL_ClearPins(PTB,(1<<16))
#define LED_FP_ON           GPIO_HAL_SetPins(PTB,(1<<15))
#define LED_FP_OFF          GPIO_HAL_ClearPins(PTB,(1<<15))

#endif /* GPIO_H_ */
